git-rebase--interactive.shon commit Merge branch 'va/i18n-even-more' (2703572)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# http://article.gmane.org/gmane.comp.version-control.git/22407
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84strategy_args=${strategy:+--strategy=$strategy}
  85test -n "$strategy_opts" &&
  86eval '
  87        for strategy_opt in '"$strategy_opts"'
  88        do
  89                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  90        done
  91'
  92
  93GIT_CHERRY_PICK_HELP="$resolvemsg"
  94export GIT_CHERRY_PICK_HELP
  95
  96comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
  97: ${comment_char:=#}
  98
  99warn () {
 100        printf '%s\n' "$*" >&2
 101}
 102
 103# Output the commit message for the specified commit.
 104commit_message () {
 105        git cat-file commit "$1" | sed "1,/^$/d"
 106}
 107
 108orig_reflog_action="$GIT_REFLOG_ACTION"
 109
 110comment_for_reflog () {
 111        case "$orig_reflog_action" in
 112        ''|rebase*)
 113                GIT_REFLOG_ACTION="rebase -i ($1)"
 114                export GIT_REFLOG_ACTION
 115                ;;
 116        esac
 117}
 118
 119last_count=
 120mark_action_done () {
 121        sed -e 1q < "$todo" >> "$done"
 122        sed -e 1d < "$todo" >> "$todo".new
 123        mv -f "$todo".new "$todo"
 124        new_count=$(git stripspace --strip-comments <"$done" | wc -l)
 125        echo $new_count >"$msgnum"
 126        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 127        echo $total >"$end"
 128        if test "$last_count" != "$new_count"
 129        then
 130                last_count=$new_count
 131                eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
 132                test -z "$verbose" || echo
 133        fi
 134}
 135
 136# Put the last action marked done at the beginning of the todo list
 137# again. If there has not been an action marked done yet, leave the list of
 138# items on the todo list unchanged.
 139reschedule_last_action () {
 140        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 141        sed -e \$d <"$done" >"$done".new
 142        mv -f "$todo".new "$todo"
 143        mv -f "$done".new "$done"
 144}
 145
 146append_todo_help () {
 147        gettext "
 148Commands:
 149 p, pick = use commit
 150 r, reword = use commit, but edit the commit message
 151 e, edit = use commit, but stop for amending
 152 s, squash = use commit, but meld into previous commit
 153 f, fixup = like \"squash\", but discard this commit's log message
 154 x, exec = run command (the rest of the line) using shell
 155 d, drop = remove commit
 156
 157These lines can be re-ordered; they are executed from top to bottom.
 158" | git stripspace --comment-lines >>"$todo"
 159
 160        if test $(get_missing_commit_check_level) = error
 161        then
 162                gettext "
 163Do not remove any line. Use 'drop' explicitly to remove a commit.
 164" | git stripspace --comment-lines >>"$todo"
 165        else
 166                gettext "
 167If you remove a line here THAT COMMIT WILL BE LOST.
 168" | git stripspace --comment-lines >>"$todo"
 169        fi
 170}
 171
 172make_patch () {
 173        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 174        case "$sha1_and_parents" in
 175        ?*' '?*' '?*)
 176                git diff --cc $sha1_and_parents
 177                ;;
 178        ?*' '?*)
 179                git diff-tree -p "$1^!"
 180                ;;
 181        *)
 182                echo "Root commit"
 183                ;;
 184        esac > "$state_dir"/patch
 185        test -f "$msg" ||
 186                commit_message "$1" > "$msg"
 187        test -f "$author_script" ||
 188                get_author_ident_from_commit "$1" > "$author_script"
 189}
 190
 191die_with_patch () {
 192        echo "$1" > "$state_dir"/stopped-sha
 193        make_patch "$1"
 194        die "$2"
 195}
 196
 197exit_with_patch () {
 198        echo "$1" > "$state_dir"/stopped-sha
 199        make_patch $1
 200        git rev-parse --verify HEAD > "$amend"
 201        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 202        warn "$(eval_gettext "\
 203You can amend the commit now, with
 204
 205        git commit --amend \$gpg_sign_opt_quoted
 206
 207Once you are satisfied with your changes, run
 208
 209        git rebase --continue")"
 210        warn
 211        exit $2
 212}
 213
 214die_abort () {
 215        rm -rf "$state_dir"
 216        die "$1"
 217}
 218
 219has_action () {
 220        test -n "$(git stripspace --strip-comments <"$1")"
 221}
 222
 223is_empty_commit() {
 224        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 225                sha1=$1
 226                die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 227        }
 228        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 229                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 230        test "$tree" = "$ptree"
 231}
 232
 233is_merge_commit()
 234{
 235        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 236}
 237
 238# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 239# GIT_AUTHOR_DATE exported from the current environment.
 240do_with_author () {
 241        (
 242                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 243                "$@"
 244        )
 245}
 246
 247git_sequence_editor () {
 248        if test -z "$GIT_SEQUENCE_EDITOR"
 249        then
 250                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 251                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 252                then
 253                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 254                fi
 255        fi
 256
 257        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 258}
 259
 260pick_one () {
 261        ff=--ff
 262
 263        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 264        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 265        output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
 266
 267        if is_empty_commit "$sha1"
 268        then
 269                empty_args="--allow-empty"
 270        fi
 271
 272        test -d "$rewritten" &&
 273                pick_one_preserving_merges "$@" && return
 274        output eval git cherry-pick \
 275                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 276                        "$strategy_args" $empty_args $ff "$@"
 277
 278        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 279        # previous task so this commit is not lost.
 280        ret=$?
 281        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 282        return $ret
 283}
 284
 285pick_one_preserving_merges () {
 286        fast_forward=t
 287        case "$1" in
 288        -n)
 289                fast_forward=f
 290                sha1=$2
 291                ;;
 292        *)
 293                sha1=$1
 294                ;;
 295        esac
 296        sha1=$(git rev-parse $sha1)
 297
 298        if test -f "$state_dir"/current-commit
 299        then
 300                if test "$fast_forward" = t
 301                then
 302                        while read current_commit
 303                        do
 304                                git rev-parse HEAD > "$rewritten"/$current_commit
 305                        done <"$state_dir"/current-commit
 306                        rm "$state_dir"/current-commit ||
 307                                die "$(gettext "Cannot write current commit's replacement sha1")"
 308                fi
 309        fi
 310
 311        echo $sha1 >> "$state_dir"/current-commit
 312
 313        # rewrite parents; if none were rewritten, we can fast-forward.
 314        new_parents=
 315        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 316        if test "$pend" = " "
 317        then
 318                pend=" root"
 319        fi
 320        while [ "$pend" != "" ]
 321        do
 322                p=$(expr "$pend" : ' \([^ ]*\)')
 323                pend="${pend# $p}"
 324
 325                if test -f "$rewritten"/$p
 326                then
 327                        new_p=$(cat "$rewritten"/$p)
 328
 329                        # If the todo reordered commits, and our parent is marked for
 330                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 331                        # drop it on top of the current HEAD
 332                        if test -z "$new_p"
 333                        then
 334                                new_p=$(git rev-parse HEAD)
 335                        fi
 336
 337                        test $p != $new_p && fast_forward=f
 338                        case "$new_parents" in
 339                        *$new_p*)
 340                                ;; # do nothing; that parent is already there
 341                        *)
 342                                new_parents="$new_parents $new_p"
 343                                ;;
 344                        esac
 345                else
 346                        if test -f "$dropped"/$p
 347                        then
 348                                fast_forward=f
 349                                replacement="$(cat "$dropped"/$p)"
 350                                test -z "$replacement" && replacement=root
 351                                pend=" $replacement$pend"
 352                        else
 353                                new_parents="$new_parents $p"
 354                        fi
 355                fi
 356        done
 357        case $fast_forward in
 358        t)
 359                output warn "$(eval_gettext "Fast-forward to \$sha1")"
 360                output git reset --hard $sha1 ||
 361                        die "$(eval_gettext "Cannot fast-forward to \$sha1")"
 362                ;;
 363        f)
 364                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 365
 366                if [ "$1" != "-n" ]
 367                then
 368                        # detach HEAD to current parent
 369                        output git checkout $first_parent 2> /dev/null ||
 370                                die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
 371                fi
 372
 373                case "$new_parents" in
 374                ' '*' '*)
 375                        test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
 376
 377                        # redo merge
 378                        author_script_content=$(get_author_ident_from_commit $sha1)
 379                        eval "$author_script_content"
 380                        msg_content="$(commit_message $sha1)"
 381                        # No point in merging the first parent, that's HEAD
 382                        new_parents=${new_parents# $first_parent}
 383                        merge_args="--no-log --no-ff"
 384                        if ! do_with_author output eval \
 385                        'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
 386                                $merge_args $strategy_args -m "$msg_content" $new_parents'
 387                        then
 388                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 389                                die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
 390                        fi
 391                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 392                        ;;
 393                *)
 394                        output eval git cherry-pick \
 395                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 396                                "$strategy_args" "$@" ||
 397                                die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
 398                        ;;
 399                esac
 400                ;;
 401        esac
 402}
 403
 404this_nth_commit_message () {
 405        n=$1
 406        case "$n" in
 407        1) gettext "This is the 1st commit message:";;
 408        2) gettext "This is the 2nd commit message:";;
 409        3) gettext "This is the 3rd commit message:";;
 410        4) gettext "This is the 4th commit message:";;
 411        5) gettext "This is the 5th commit message:";;
 412        6) gettext "This is the 6th commit message:";;
 413        7) gettext "This is the 7th commit message:";;
 414        8) gettext "This is the 8th commit message:";;
 415        9) gettext "This is the 9th commit message:";;
 416        10) gettext "This is the 10th commit message:";;
 417        # TRANSLATORS: if the language you are translating into
 418        # doesn't allow you to compose a sentence in this fashion,
 419        # consider translating as if this and the following few strings
 420        # were "This is the commit message ${n}:"
 421        *1[0-9]|*[04-9]) eval_gettext "This is the \${n}th commit message:";;
 422        *1) eval_gettext "This is the \${n}st commit message:";;
 423        *2) eval_gettext "This is the \${n}nd commit message:";;
 424        *3) eval_gettext "This is the \${n}rd commit message:";;
 425        *) eval_gettext "This is the commit message \${n}:";;
 426        esac
 427}
 428skip_nth_commit_message () {
 429        n=$1
 430        case "$n" in
 431        1) gettext "The 1st commit message will be skipped:";;
 432        2) gettext "The 2nd commit message will be skipped:";;
 433        3) gettext "The 3rd commit message will be skipped:";;
 434        4) gettext "The 4th commit message will be skipped:";;
 435        5) gettext "The 5th commit message will be skipped:";;
 436        6) gettext "The 6th commit message will be skipped:";;
 437        7) gettext "The 7th commit message will be skipped:";;
 438        8) gettext "The 8th commit message will be skipped:";;
 439        9) gettext "The 9th commit message will be skipped:";;
 440        10) gettext "The 10th commit message will be skipped:";;
 441        # TRANSLATORS: if the language you are translating into
 442        # doesn't allow you to compose a sentence in this fashion,
 443        # consider translating as if this and the following few strings
 444        # were "The commit message ${n} will be skipped:"
 445        *1[0-9]|*[04-9]) eval_gettext "The \${n}th commit message will be skipped:";;
 446        *1) eval_gettext "The \${n}st commit message will be skipped:";;
 447        *2) eval_gettext "The \${n}nd commit message will be skipped:";;
 448        *3) eval_gettext "The \${n}rd commit message will be skipped:";;
 449        *) eval_gettext "The commit message \${n} will be skipped:";;
 450        esac
 451}
 452
 453update_squash_messages () {
 454        if test -f "$squash_msg"; then
 455                mv "$squash_msg" "$squash_msg".bak || exit
 456                count=$(($(sed -n \
 457                        -e "1s/^$comment_char.*\([0-9][0-9]*\).*/\1/p" \
 458                        -e "q" < "$squash_msg".bak)+1))
 459                {
 460                        printf '%s\n' "$comment_char $(eval_ngettext \
 461                                "This is a combination of \$count commit." \
 462                                "This is a combination of \$count commits." \
 463                                $count)"
 464                        sed -e 1d -e '2,/^./{
 465                                /^$/d
 466                        }' <"$squash_msg".bak
 467                } >"$squash_msg"
 468        else
 469                commit_message HEAD > "$fixup_msg" || die "$(gettext "Cannot write \$fixup_msg")"
 470                count=2
 471                {
 472                        printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 473                        printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
 474                        echo
 475                        cat "$fixup_msg"
 476                } >"$squash_msg"
 477        fi
 478        case $1 in
 479        squash)
 480                rm -f "$fixup_msg"
 481                echo
 482                printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
 483                echo
 484                commit_message $2
 485                ;;
 486        fixup)
 487                echo
 488                printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
 489                echo
 490                # Change the space after the comment character to TAB:
 491                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 492                ;;
 493        esac >>"$squash_msg"
 494}
 495
 496peek_next_command () {
 497        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 498}
 499
 500# A squash/fixup has failed.  Prepare the long version of the squash
 501# commit message, then die_with_patch.  This code path requires the
 502# user to edit the combined commit message for all commits that have
 503# been squashed/fixedup so far.  So also erase the old squash
 504# messages, effectively causing the combined commit to be used as the
 505# new basis for any further squash/fixups.  Args: sha1 rest
 506die_failed_squash() {
 507        sha1=$1
 508        rest=$2
 509        mv "$squash_msg" "$msg" || exit
 510        rm -f "$fixup_msg"
 511        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 512        warn
 513        warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 514        die_with_patch $sha1 ""
 515}
 516
 517flush_rewritten_pending() {
 518        test -s "$rewritten_pending" || return
 519        newsha1="$(git rev-parse HEAD^0)"
 520        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 521        rm -f "$rewritten_pending"
 522}
 523
 524record_in_rewritten() {
 525        oldsha1="$(git rev-parse $1)"
 526        echo "$oldsha1" >> "$rewritten_pending"
 527
 528        case "$(peek_next_command)" in
 529        squash|s|fixup|f)
 530                ;;
 531        *)
 532                flush_rewritten_pending
 533                ;;
 534        esac
 535}
 536
 537do_pick () {
 538        sha1=$1
 539        rest=$2
 540        if test "$(git rev-parse HEAD)" = "$squash_onto"
 541        then
 542                # Set the correct commit message and author info on the
 543                # sentinel root before cherry-picking the original changes
 544                # without committing (-n).  Finally, update the sentinel again
 545                # to include these changes.  If the cherry-pick results in a
 546                # conflict, this means our behaviour is similar to a standard
 547                # failed cherry-pick during rebase, with a dirty index to
 548                # resolve before manually running git commit --amend then git
 549                # rebase --continue.
 550                git commit --allow-empty --allow-empty-message --amend \
 551                           --no-post-rewrite -n -q -C $sha1 &&
 552                        pick_one -n $sha1 &&
 553                        git commit --allow-empty --allow-empty-message \
 554                                   --amend --no-post-rewrite -n -q -C $sha1 \
 555                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 556                                   die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 557        else
 558                pick_one $sha1 ||
 559                        die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 560        fi
 561}
 562
 563do_next () {
 564        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 565        read -r command sha1 rest < "$todo"
 566        case "$command" in
 567        "$comment_char"*|''|noop|drop|d)
 568                mark_action_done
 569                ;;
 570        "$cr")
 571                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 572                mark_action_done
 573                ;;
 574        pick|p)
 575                comment_for_reflog pick
 576
 577                mark_action_done
 578                do_pick $sha1 "$rest"
 579                record_in_rewritten $sha1
 580                ;;
 581        reword|r)
 582                comment_for_reflog reword
 583
 584                mark_action_done
 585                do_pick $sha1 "$rest"
 586                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
 587                        warn "$(eval_gettext "\
 588Could not amend commit after successfully picking \$sha1... \$rest
 589This is most likely due to an empty commit message, or the pre-commit hook
 590failed. If the pre-commit hook failed, you may need to resolve the issue before
 591you are able to reword the commit.")"
 592                        exit_with_patch $sha1 1
 593                }
 594                record_in_rewritten $sha1
 595                ;;
 596        edit|e)
 597                comment_for_reflog edit
 598
 599                mark_action_done
 600                do_pick $sha1 "$rest"
 601                sha1_abbrev=$(git rev-parse --short $sha1)
 602                warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
 603                exit_with_patch $sha1 0
 604                ;;
 605        squash|s|fixup|f)
 606                case "$command" in
 607                squash|s)
 608                        squash_style=squash
 609                        ;;
 610                fixup|f)
 611                        squash_style=fixup
 612                        ;;
 613                esac
 614                comment_for_reflog $squash_style
 615
 616                test -f "$done" && has_action "$done" ||
 617                        die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
 618
 619                mark_action_done
 620                update_squash_messages $squash_style $sha1
 621                author_script_content=$(get_author_ident_from_commit HEAD)
 622                echo "$author_script_content" > "$author_script"
 623                eval "$author_script_content"
 624                if ! pick_one -n $sha1
 625                then
 626                        git rev-parse --verify HEAD >"$amend"
 627                        die_failed_squash $sha1 "$rest"
 628                fi
 629                case "$(peek_next_command)" in
 630                squash|s|fixup|f)
 631                        # This is an intermediate commit; its message will only be
 632                        # used in case of trouble.  So use the long version:
 633                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 634                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 635                                die_failed_squash $sha1 "$rest"
 636                        ;;
 637                *)
 638                        # This is the final command of this squash/fixup group
 639                        if test -f "$fixup_msg"
 640                        then
 641                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 642                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 643                                        die_failed_squash $sha1 "$rest"
 644                        else
 645                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 646                                rm -f "$GIT_DIR"/MERGE_MSG
 647                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 648                                        ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 649                                        die_failed_squash $sha1 "$rest"
 650                        fi
 651                        rm -f "$squash_msg" "$fixup_msg"
 652                        ;;
 653                esac
 654                record_in_rewritten $sha1
 655                ;;
 656        x|"exec")
 657                read -r command rest < "$todo"
 658                mark_action_done
 659                eval_gettextln "Executing: \$rest"
 660                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 661                status=$?
 662                # Run in subshell because require_clean_work_tree can die.
 663                dirty=f
 664                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 665                if test "$status" -ne 0
 666                then
 667                        warn "$(eval_gettext "Execution failed: \$rest")"
 668                        test "$dirty" = f ||
 669                                warn "$(gettext "and made changes to the index and/or the working tree")"
 670
 671                        warn "$(gettext "\
 672You can fix the problem, and then run
 673
 674        git rebase --continue")"
 675                        warn
 676                        if test $status -eq 127         # command not found
 677                        then
 678                                status=1
 679                        fi
 680                        exit "$status"
 681                elif test "$dirty" = t
 682                then
 683                        # TRANSLATORS: after these lines is a command to be issued by the user
 684                        warn "$(eval_gettext "\
 685Execution succeeded: \$rest
 686but left changes to the index and/or the working tree
 687Commit or stash your changes, and then run
 688
 689        git rebase --continue")"
 690                        warn
 691                        exit 1
 692                fi
 693                ;;
 694        *)
 695                warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 696                fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
 697                if git rev-parse --verify -q "$sha1" >/dev/null
 698                then
 699                        die_with_patch $sha1 "$fixtodo"
 700                else
 701                        die "$fixtodo"
 702                fi
 703                ;;
 704        esac
 705        test -s "$todo" && return
 706
 707        comment_for_reflog finish &&
 708        newhead=$(git rev-parse HEAD) &&
 709        case $head_name in
 710        refs/*)
 711                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 712                git update-ref -m "$message" $head_name $newhead $orig_head &&
 713                git symbolic-ref \
 714                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 715                  HEAD $head_name
 716                ;;
 717        esac && {
 718                test ! -f "$state_dir"/verbose ||
 719                        git diff-tree --stat $orig_head..HEAD
 720        } &&
 721        {
 722                test -s "$rewritten_list" &&
 723                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 724                true # we don't care if this copying failed
 725        } &&
 726        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 727        if test -x "$hook" && test -s "$rewritten_list"; then
 728                "$hook" rebase < "$rewritten_list"
 729                true # we don't care if this hook failed
 730        fi &&
 731                warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
 732
 733        return 1 # not failure; just to break the do_rest loop
 734}
 735
 736# can only return 0, when the infinite loop breaks
 737do_rest () {
 738        while :
 739        do
 740                do_next || break
 741        done
 742}
 743
 744# skip picking commits whose parents are unchanged
 745skip_unnecessary_picks () {
 746        fd=3
 747        while read -r command rest
 748        do
 749                # fd=3 means we skip the command
 750                case "$fd,$command" in
 751                3,pick|3,p)
 752                        # pick a commit whose parent is current $onto -> skip
 753                        sha1=${rest%% *}
 754                        case "$(git rev-parse --verify --quiet "$sha1"^)" in
 755                        "$onto"*)
 756                                onto=$sha1
 757                                ;;
 758                        *)
 759                                fd=1
 760                                ;;
 761                        esac
 762                        ;;
 763                3,"$comment_char"*|3,)
 764                        # copy comments
 765                        ;;
 766                *)
 767                        fd=1
 768                        ;;
 769                esac
 770                printf '%s\n' "$command${rest:+ }$rest" >&$fd
 771        done <"$todo" >"$todo.new" 3>>"$done" &&
 772        mv -f "$todo".new "$todo" &&
 773        case "$(peek_next_command)" in
 774        squash|s|fixup|f)
 775                record_in_rewritten "$onto"
 776                ;;
 777        esac ||
 778                die "$(gettext "Could not skip unnecessary pick commands")"
 779}
 780
 781transform_todo_ids () {
 782        while read -r command rest
 783        do
 784                case "$command" in
 785                "$comment_char"* | exec)
 786                        # Be careful for oddball commands like 'exec'
 787                        # that do not have a SHA-1 at the beginning of $rest.
 788                        ;;
 789                *)
 790                        sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[     ]*}) &&
 791                        rest="$sha1 ${rest#*[    ]}"
 792                        ;;
 793                esac
 794                printf '%s\n' "$command${rest:+ }$rest"
 795        done <"$todo" >"$todo.new" &&
 796        mv -f "$todo.new" "$todo"
 797}
 798
 799expand_todo_ids() {
 800        transform_todo_ids
 801}
 802
 803collapse_todo_ids() {
 804        transform_todo_ids --short
 805}
 806
 807# Rearrange the todo list that has both "pick sha1 msg" and
 808# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 809# comes immediately after the former, and change "pick" to
 810# "fixup"/"squash".
 811#
 812# Note that if the config has specified a custom instruction format
 813# each log message will be re-retrieved in order to normalize the
 814# autosquash arrangement
 815rearrange_squash () {
 816        # extract fixup!/squash! lines and resolve any referenced sha1's
 817        while read -r pick sha1 message
 818        do
 819                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 820                case "$message" in
 821                "squash! "*|"fixup! "*)
 822                        action="${message%%!*}"
 823                        rest=$message
 824                        prefix=
 825                        # skip all squash! or fixup! (but save for later)
 826                        while :
 827                        do
 828                                case "$rest" in
 829                                "squash! "*|"fixup! "*)
 830                                        prefix="$prefix${rest%%!*},"
 831                                        rest="${rest#*! }"
 832                                        ;;
 833                                *)
 834                                        break
 835                                        ;;
 836                                esac
 837                        done
 838                        printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
 839                        # if it's a single word, try to resolve to a full sha1 and
 840                        # emit a second copy. This allows us to match on both message
 841                        # and on sha1 prefix
 842                        if test "${rest#* }" = "$rest"; then
 843                                fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
 844                                if test -n "$fullsha"; then
 845                                        # prefix the action to uniquely identify this line as
 846                                        # intended for full sha1 match
 847                                        echo "$sha1 +$action $prefix $fullsha"
 848                                fi
 849                        fi
 850                esac
 851        done >"$1.sq" <"$1"
 852        test -s "$1.sq" || return
 853
 854        used=
 855        while read -r pick sha1 message
 856        do
 857                case " $used" in
 858                *" $sha1 "*) continue ;;
 859                esac
 860                printf '%s\n' "$pick $sha1 $message"
 861                test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
 862                used="$used$sha1 "
 863                while read -r squash action msg_prefix msg_content
 864                do
 865                        case " $used" in
 866                        *" $squash "*) continue ;;
 867                        esac
 868                        emit=0
 869                        case "$action" in
 870                        +*)
 871                                action="${action#+}"
 872                                # full sha1 prefix test
 873                                case "$msg_content" in "$sha1"*) emit=1;; esac ;;
 874                        *)
 875                                # message prefix test
 876                                case "$message" in "$msg_content"*) emit=1;; esac ;;
 877                        esac
 878                        if test $emit = 1; then
 879                                if test -n "${format}"
 880                                then
 881                                        msg_content=$(git log -n 1 --format="${format}" ${squash})
 882                                else
 883                                        msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
 884                                fi
 885                                printf '%s\n' "$action $squash $msg_content"
 886                                used="$used$squash "
 887                        fi
 888                done <"$1.sq"
 889        done >"$1.rearranged" <"$1"
 890        cat "$1.rearranged" >"$1"
 891        rm -f "$1.sq" "$1.rearranged"
 892}
 893
 894# Add commands after a pick or after a squash/fixup serie
 895# in the todo list.
 896add_exec_commands () {
 897        {
 898                first=t
 899                while read -r insn rest
 900                do
 901                        case $insn in
 902                        pick)
 903                                test -n "$first" ||
 904                                printf "%s" "$cmd"
 905                                ;;
 906                        esac
 907                        printf "%s %s\n" "$insn" "$rest"
 908                        first=
 909                done
 910                printf "%s" "$cmd"
 911        } <"$1" >"$1.new" &&
 912        mv "$1.new" "$1"
 913}
 914
 915# Check if the SHA-1 passed as an argument is a
 916# correct one, if not then print $2 in "$todo".badsha
 917# $1: the SHA-1 to test
 918# $2: the line number of the input
 919# $3: the input filename
 920check_commit_sha () {
 921        badsha=0
 922        if test -z "$1"
 923        then
 924                badsha=1
 925        else
 926                sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
 927                if test -z "$sha1_verif"
 928                then
 929                        badsha=1
 930                fi
 931        fi
 932
 933        if test $badsha -ne 0
 934        then
 935                line="$(sed -n -e "${2}p" "$3")"
 936                warn "$(eval_gettext "\
 937Warning: the SHA-1 is missing or isn't a commit in the following line:
 938 - \$line")"
 939                warn
 940        fi
 941
 942        return $badsha
 943}
 944
 945# prints the bad commits and bad commands
 946# from the todolist in stdin
 947check_bad_cmd_and_sha () {
 948        retval=0
 949        lineno=0
 950        while read -r command rest
 951        do
 952                lineno=$(( $lineno + 1 ))
 953                case $command in
 954                "$comment_char"*|''|noop|x|exec)
 955                        # Doesn't expect a SHA-1
 956                        ;;
 957                "$cr")
 958                        # Work around CR left by "read" (e.g. with Git for
 959                        # Windows' Bash).
 960                        ;;
 961                pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
 962                        if ! check_commit_sha "${rest%%[        ]*}" "$lineno" "$1"
 963                        then
 964                                retval=1
 965                        fi
 966                        ;;
 967                *)
 968                        line="$(sed -n -e "${lineno}p" "$1")"
 969                        warn "$(eval_gettext "\
 970Warning: the command isn't recognized in the following line:
 971 - \$line")"
 972                        warn
 973                        retval=1
 974                        ;;
 975                esac
 976        done <"$1"
 977        return $retval
 978}
 979
 980# Print the list of the SHA-1 of the commits
 981# from stdin to stdout
 982todo_list_to_sha_list () {
 983        git stripspace --strip-comments |
 984        while read -r command sha1 rest
 985        do
 986                case $command in
 987                "$comment_char"*|''|noop|x|"exec")
 988                        ;;
 989                *)
 990                        long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
 991                        printf "%s\n" "$long_sha"
 992                        ;;
 993                esac
 994        done
 995}
 996
 997# Use warn for each line in stdin
 998warn_lines () {
 999        while read -r line
1000        do
1001                warn " - $line"
1002        done
1003}
1004
1005# Switch to the branch in $into and notify it in the reflog
1006checkout_onto () {
1007        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
1008        output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
1009        git update-ref ORIG_HEAD $orig_head
1010}
1011
1012get_missing_commit_check_level () {
1013        check_level=$(git config --get rebase.missingCommitsCheck)
1014        check_level=${check_level:-ignore}
1015        # Don't be case sensitive
1016        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
1017}
1018
1019# Check if the user dropped some commits by mistake
1020# Behaviour determined by rebase.missingCommitsCheck.
1021# Check if there is an unrecognized command or a
1022# bad SHA-1 in a command.
1023check_todo_list () {
1024        raise_error=f
1025
1026        check_level=$(get_missing_commit_check_level)
1027
1028        case "$check_level" in
1029        warn|error)
1030                # Get the SHA-1 of the commits
1031                todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
1032                todo_list_to_sha_list <"$todo" >"$todo".newsha1
1033
1034                # Sort the SHA-1 and compare them
1035                sort -u "$todo".oldsha1 >"$todo".oldsha1+
1036                mv "$todo".oldsha1+ "$todo".oldsha1
1037                sort -u "$todo".newsha1 >"$todo".newsha1+
1038                mv "$todo".newsha1+ "$todo".newsha1
1039                comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
1040
1041                # Warn about missing commits
1042                if test -s "$todo".miss
1043                then
1044                        test "$check_level" = error && raise_error=t
1045
1046                        warn "$(gettext "\
1047Warning: some commits may have been dropped accidentally.
1048Dropped commits (newer to older):")"
1049
1050                        # Make the list user-friendly and display
1051                        opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1052                        git rev-list $opt <"$todo".miss | warn_lines
1053
1054                        warn "$(gettext "\
1055To avoid this message, use \"drop\" to explicitly remove a commit.
1056
1057Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
1058The possible behaviours are: ignore, warn, error.")"
1059                        warn
1060                fi
1061                ;;
1062        ignore)
1063                ;;
1064        *)
1065                warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
1066                ;;
1067        esac
1068
1069        if ! check_bad_cmd_and_sha "$todo"
1070        then
1071                raise_error=t
1072        fi
1073
1074        if test $raise_error = t
1075        then
1076                # Checkout before the first commit of the
1077                # rebase: this way git rebase --continue
1078                # will work correctly as it expects HEAD to be
1079                # placed before the commit of the next action
1080                checkout_onto
1081
1082                warn "$(gettext "You can fix this with 'git rebase --edit-todo'.")"
1083                die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
1084        fi
1085}
1086
1087# The whole contents of this file is run by dot-sourcing it from
1088# inside a shell function.  It used to be that "return"s we see
1089# below were not inside any function, and expected to return
1090# to the function that dot-sourced us.
1091#
1092# However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
1093# construct and continue to run the statements that follow such a "return".
1094# As a work-around, we introduce an extra layer of a function
1095# here, and immediately call it after defining it.
1096git_rebase__interactive () {
1097
1098case "$action" in
1099continue)
1100        # do we have anything to commit?
1101        if git diff-index --cached --quiet HEAD --
1102        then
1103                # Nothing to commit -- skip this commit
1104
1105                test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1106                rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1107                die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
1108        else
1109                if ! test -f "$author_script"
1110                then
1111                        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1112                        die "$(eval_gettext "\
1113You have staged changes in your working tree.
1114If these changes are meant to be
1115squashed into the previous commit, run:
1116
1117  git commit --amend \$gpg_sign_opt_quoted
1118
1119If they are meant to go into a new commit, run:
1120
1121  git commit \$gpg_sign_opt_quoted
1122
1123In both case, once you're done, continue with:
1124
1125  git rebase --continue
1126")"
1127                fi
1128                . "$author_script" ||
1129                        die "$(gettext "Error trying to find the author identity to amend commit")"
1130                if test -f "$amend"
1131                then
1132                        current_head=$(git rev-parse --verify HEAD)
1133                        test "$current_head" = $(cat "$amend") ||
1134                        die "$(gettext "\
1135You have uncommitted changes in your working tree. Please commit them
1136first and then run 'git rebase --continue' again.")"
1137                        do_with_author git commit --amend --no-verify -F "$msg" -e \
1138                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1139                                die "$(gettext "Could not commit staged changes.")"
1140                else
1141                        do_with_author git commit --no-verify -F "$msg" -e \
1142                                ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1143                                die "$(gettext "Could not commit staged changes.")"
1144                fi
1145        fi
1146
1147        if test -r "$state_dir"/stopped-sha
1148        then
1149                record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1150        fi
1151
1152        require_clean_work_tree "rebase"
1153        do_rest
1154        return 0
1155        ;;
1156skip)
1157        git rerere clear
1158
1159        do_rest
1160        return 0
1161        ;;
1162edit-todo)
1163        git stripspace --strip-comments <"$todo" >"$todo".new
1164        mv -f "$todo".new "$todo"
1165        collapse_todo_ids
1166        append_todo_help
1167        gettext "
1168You are editing the todo file of an ongoing interactive rebase.
1169To continue rebase after editing, run:
1170    git rebase --continue
1171
1172" | git stripspace --comment-lines >>"$todo"
1173
1174        git_sequence_editor "$todo" ||
1175                die "$(gettext "Could not execute editor")"
1176        expand_todo_ids
1177
1178        exit
1179        ;;
1180esac
1181
1182git var GIT_COMMITTER_IDENT >/dev/null ||
1183        die "$(gettext "You need to set your committer info first")"
1184
1185comment_for_reflog start
1186
1187if test ! -z "$switch_to"
1188then
1189        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1190        output git checkout "$switch_to" -- ||
1191                die "$(eval_gettext "Could not checkout \$switch_to")"
1192
1193        comment_for_reflog start
1194fi
1195
1196orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
1197mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
1198
1199: > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
1200write_basic_state
1201if test t = "$preserve_merges"
1202then
1203        if test -z "$rebase_root"
1204        then
1205                mkdir "$rewritten" &&
1206                for c in $(git merge-base --all $orig_head $upstream)
1207                do
1208                        echo $onto > "$rewritten"/$c ||
1209                                die "$(gettext "Could not init rewritten commits")"
1210                done
1211        else
1212                mkdir "$rewritten" &&
1213                echo $onto > "$rewritten"/root ||
1214                        die "$(gettext "Could not init rewritten commits")"
1215        fi
1216        # No cherry-pick because our first pass is to determine
1217        # parents to rewrite and skipping dropped commits would
1218        # prematurely end our probe
1219        merges_option=
1220else
1221        merges_option="--no-merges --cherry-pick"
1222fi
1223
1224shorthead=$(git rev-parse --short $orig_head)
1225shortonto=$(git rev-parse --short $onto)
1226if test -z "$rebase_root"
1227        # this is now equivalent to ! -z "$upstream"
1228then
1229        shortupstream=$(git rev-parse --short $upstream)
1230        revisions=$upstream...$orig_head
1231        shortrevisions=$shortupstream..$shorthead
1232else
1233        revisions=$onto...$orig_head
1234        shortrevisions=$shorthead
1235fi
1236format=$(git config --get rebase.instructionFormat)
1237# the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1238git rev-list $merges_option --format="%m%H ${format:-%s}" \
1239        --reverse --left-right --topo-order \
1240        $revisions ${restrict_revision+^$restrict_revision} | \
1241        sed -n "s/^>//p" |
1242while read -r sha1 rest
1243do
1244
1245        if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1246        then
1247                comment_out="$comment_char "
1248        else
1249                comment_out=
1250        fi
1251
1252        if test t != "$preserve_merges"
1253        then
1254                printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1255        else
1256                if test -z "$rebase_root"
1257                then
1258                        preserve=t
1259                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1260                        do
1261                                if test -f "$rewritten"/$p
1262                                then
1263                                        preserve=f
1264                                fi
1265                        done
1266                else
1267                        preserve=f
1268                fi
1269                if test f = "$preserve"
1270                then
1271                        touch "$rewritten"/$sha1
1272                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1273                fi
1274        fi
1275done
1276
1277# Watch for commits that been dropped by --cherry-pick
1278if test t = "$preserve_merges"
1279then
1280        mkdir "$dropped"
1281        # Save all non-cherry-picked changes
1282        git rev-list $revisions --left-right --cherry-pick | \
1283                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1284        # Now all commits and note which ones are missing in
1285        # not-cherry-picks and hence being dropped
1286        git rev-list $revisions |
1287        while read rev
1288        do
1289                if test -f "$rewritten"/$rev &&
1290                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1291                then
1292                        # Use -f2 because if rev-list is telling us this commit is
1293                        # not worthwhile, we don't want to track its multiple heads,
1294                        # just the history of its first-parent for others that will
1295                        # be rebasing on top of it
1296                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1297                        sha1=$(git rev-list -1 $rev)
1298                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1299                        rm "$rewritten"/$rev
1300                fi
1301        done
1302fi
1303
1304test -s "$todo" || echo noop >> "$todo"
1305test -n "$autosquash" && rearrange_squash "$todo"
1306test -n "$cmd" && add_exec_commands "$todo"
1307
1308todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1309todocount=${todocount##* }
1310
1311cat >>"$todo" <<EOF
1312
1313$comment_char $(eval_ngettext \
1314        "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
1315        "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
1316        "$todocount")
1317EOF
1318append_todo_help
1319gettext "
1320However, if you remove everything, the rebase will be aborted.
1321
1322" | git stripspace --comment-lines >>"$todo"
1323
1324if test -z "$keep_empty"
1325then
1326        printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1327fi
1328
1329
1330has_action "$todo" ||
1331        return 2
1332
1333cp "$todo" "$todo".backup
1334collapse_todo_ids
1335git_sequence_editor "$todo" ||
1336        die_abort "$(gettext "Could not execute editor")"
1337
1338has_action "$todo" ||
1339        return 2
1340
1341check_todo_list
1342
1343expand_todo_ids
1344
1345test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1346
1347checkout_onto
1348do_rest
1349
1350}
1351# ... and then we call the whole thing.
1352git_rebase__interactive